<template>
  <div class="page-container h-screen pa-2">
    <PageTitle :title="translate('pages.products.index.title')" />

    <div class="flex flex-col justify-between px-8">
      <div class="d-flex justify-end">
        <button-create :to="{name: 'products.create',}"></button-create>
      </div>



      <!-- Data Table -->

      <v-data-table-server
        v-model:items-per-page="data.itemsPerPage"
        :headers="filterHeaders"
        :items-length="data.totalItems"
        :items="data.serverItems"
        :loading="data.loading"
        @update:options="loadItems"
        :items-per-page-options="data.itemsPerPageOptions"
        fixed-header
      >
        <template #item.thumbnail="{ item }">
          <ThumbnailImage :url="item.thumbnail" />
        </template>

        <template #item.is_visible="{ item }">
          <VisibilityChip :flag="item.is_visible" />
        </template>

        <template #item.popularity="{ item }">
          <div class="d-flex justify-center">
              <PopularityRating :size="24" :current="item.popularity" />
          </div>
        </template>

        <template v-slot:[`item.actions`]="{ item }">
          <td class="w-full d-block">
            <div class="text-center">
              <v-menu v-if="Object.keys(filterActions).length > 0">
                <template v-slot:activator="{ props }">
                  <div color="primary" v-bind="props" class="w-full">
                    <v-icon
                      icon="mdi-dots-vertical"
                      class="text-bodyGray cursor-pointer hover:text-tertiary transform transition-color duration-300"
                    ></v-icon>
                  </div>
                </template>

                <v-list density="compact" class="!shadow-md">
                  <v-list-item
                    v-for="action in filterActions as TableAction[]"
                    :key="action.title"
                    class="hover:cursor-pointer hover:bg-gray-medium"
                    @click="action.process(item)"
                  >
                    <v-list-item-title>
                      {{ action.title }}
                    </v-list-item-title>
                  </v-list-item>
                </v-list>
              </v-menu>
            </div>
          </td>
        </template>
        <!-- // Empty v-slot:bottom needed to hide default footer inside table -->
        <template v-slot:bottom></template>
      </v-data-table-server>

    </div>

    <Pagination v-if="data.totalItems > 10" :data="data" :loadItems="loadItems"></Pagination>
  </div>

</template>

<script lang="ts" setup>
import { ref, computed, watch } from 'vue';
import { useI18n } from 'vue-i18n'
import { useRouter } from 'vue-router'
import { storeFactory } from '@/main'

import type { VuetifyPagination, VuetifyDataTableServer, TableAction } from '@/types/tableTypes'
import PageTitle from '@/components/page/PageTitle.vue'
import { ProductsGuard } from '@/guards/ProductsGuard'
import { ObjectHelper } from '@/helpers/ObjectHelper'

import ButtonCreate from '@/components/button/ButtonCreate.vue'
import VisibilityChip from '@/components/chip/VisibilityChip.vue'
import PopularityRating from '@/components/rating/PopularityRating.vue'
import ThumbnailImage from '@/components/image/ThumbnailImage.vue'

const productGuard = new ProductsGuard()
const productStore = storeFactory.productStore;

const router = useRouter();
const objectHelper = new ObjectHelper();
const { t: translate } = useI18n()

const data = ref<VuetifyDataTableServer>({
  itemsPerPage: 10,
  headers: computed(() => {
    return [
      {
        title: translate('pages.products.columns.thumbnail'),
        key: 'thumbnail',
        align: 'start',
        sortable: false,
      },
      {
        title: translate('pages.products.columns.name'),
        key: 'name',
        align: 'start',
        sortable: false,
      },
      {
        title: translate('pages.products.columns.category_name'),
        key: 'category_name',
        align: 'start',
        sortable: false,
      },
      {
        title: translate('pages.products.columns.in_stock'),
        key: 'in_stock',
        align: 'center',
        sortable: false,
      },
      {
        title: translate('pages.products.columns.visibility'),
        key: 'is_visible',
        align: 'center',
        sortable: false,
      },
      {
        title: translate('pages.products.columns.popularity'),
        key: 'popularity',
        align: 'center',
        sortable: false,
      },
      {
        title: translate('actions.title'),
        key: 'actions',
        align: 'center',
        sortable: false,
      },
    ];
  }),
  serverItems: [],
  loading: true,
  totalItems: 0,
  search: {
    name: '',
    language_iso_code: '',
    type: '',
  },
  page: 1,
  actions: computed(() => {
    return {
      show: {
        title: translate('actions.show'),
        icon: 'mdi-account-search',
        process: show,
        isAllowed: productGuard.canShow(),
      },
      edit: {
        title: translate('actions.edit'),
        icon: 'mdi-account-edit',
        process: edit,
        isAllowed: productGuard.canUpdate(),
      },
    };
  }),

  itemsPerPageOptions: [
    { title: '10', value: 10 },
    { title: '25', value: 25 },
    { title: '50', value: 50 },
    { title: '100', value: 100 },
  ],
});

const show = async (company: any) => {
  //TODO: preload store
  await router.push({ name: 'companies.show', params: { id: company.id } });
};

const edit = async (company: any) => {
  //TODO: preload store
  await router.push({ name: 'companies.edit', params: { id: company.id } });
};

const filterHeaders = computed(() => {
  const headers = data.value.headers;

  if (Object.keys(filterActions.value).length <= 0) {
    headers.pop();
  }

  return headers;
});

const filterActions = computed((): TableAction[] | {} => {
  return objectHelper.filterAllowed(data.value.actions)
})
const loadItems = (options: VuetifyPagination) => {
  data.value.serverItems = [
    { thumbnail:'https://cdn-icons-png.flaticon.com/512/1012/1012677.png', name: 'Loremipsumator', category_name: 'Things', in_stock: 23, is_visible: true, popularity: 8},
    { thumbnail:'', name: 'Vafanculator', category_name: 'Dingitjes', in_stock: 3, is_visible: true, popularity: null},
    { thumbnail:'https://cdn-icons-png.flaticon.com/512/1012/1012677.png', name: 'Curvulating', category_name: 'Accessory', in_stock: 1, is_visible: false, popularity: 2},
  ];
  data.value.totalItems = 2;
  data.value.loading = false;
  return; //TODO: remove, example

  // ---------------------

  const searchData: any = objectHelper.filterEmpty(data.value.search, true);

  if (options.page) {
    data.value.page = options.page;
  }

  searchData.page = options.page ?? data.value.page;
  searchData.limit = options.itemsPerPage ?? data.value.itemsPerPage;
  data.value.loading = true;

  productStore
    .search(searchData)
    .then(({ items, total }: any): void => {
      data.value.serverItems = items;
      data.value.totalItems = total;
      data.value.loading = false;
    })
    .catch(() => {
      data.value.loading = false;
    });
};

// Watch for changes in data.page and reload items when it changes
watch(
  () => data.value.page,
  () => loadItems({ page: data.value.page } as VuetifyPagination)
);

</script>
